develooper Front page | perl.perl5.porters | Postings from September 2011

[perl #99984] Incorrect error message with our $::e

Thread Next
From:
Father Chrysostomos
Date:
September 25, 2011 20:03
Subject:
[perl #99984] Incorrect error message with our $::e
Message ID:
rt-3.6.HEAD-31297-1317006193-1032.99984-75-0@perl.org
# New Ticket Created by  Father Chrysostomos 
# Please include the string:  [perl #99984]
# in the subject line of all future correspondence about this issue. 
# <URL: https://rt.perl.org:443/rt3/Ticket/Display.html?id=99984 >


$ perl5.15.0 -Mutf8 -Ilib -le 'use strict; our $::é; $é'
No package name allowed for variable $::é in "our" at -e line 1, near "our $::é"
Can't use global $::é in "my" at -e line 1, near "our $::é"
Compilation error at lib/utf8_heavy.pl line 461.

It should not be mentioning utf8_heavy.pl.

The exact list of messages has changed slightly over time, but it started mentioning utf8_heavy.pl with this commit:

commit ca4cfd28534303b82a216cfe83a1c80cbc3b9dc5
Author: Dave Mitchell <davem@fdisolutions.com>
Date:   Sat Feb 9 14:56:23 2008 +0000

    [perl #49472] Attributes + Unkown Error
    An errored attribute sub still processes the attributes,
    which require's attribute.pm, so make sure the error state is
    passed to the new require
    
    p4raw-id: //depot/perl@33265

I tried reverting it and got this:

$ ./perl -Mutf8 -Ilib -le 'use strict; our $::é; $é'
Variable "$é" is not imported at -e line 1.
No package name allowed for variable $::é in "our" at -e line 1, near "our $::é"
Can't use global $::é in "my" at -e line 1, near "our $::é"
Global symbol "$?" requires explicit package name at -e line 1.
Execution of -e aborted due to compilation errors.

But I don’t really understand what is going on, and the problem it fixed (wrong error message when using attributes; very similar to the utf8_heavy.pl problem) reëmerges.

Interestingly, the ' package separator solves the problem:

$ perl5.15.0 -Mutf8 -Ilib -le 'use strict; our $'\''é; $é'
Variable "$é" is not imported at -e line 1.
No package name allowed for variable $::é in "our" at -e line 1, near "our $'é"
Can't use global $::é in "my" at -e line 1, near "our $'é"
Global symbol "$?" requires explicit package name at -e line 1.
Execution of -e aborted due to compilation errors.
Pint:~ sprout$ 

Now I have an excuse to promote it. :-)

---
Flags:
    category=core
    severity=low
---
Site configuration information for perl 5.15.0:

Configured by sprout at Thu Jun 16 05:42:17 PDT 2011.

Summary of my perl5 (revision 5 version 15 subversion 0) configuration:
  Snapshot of: 00b4043708e2509400eff8f5e4cb870d388854d4
  Platform:
    osname=darwin, osvers=10.5.0, archname=darwin-thread-multi-2level
    uname='darwin pint.local 10.5.0 darwin kernel version 10.5.0: fri nov 5 23:20:39 pdt 2010; root:xnu-1504.9.17~1release_i386 i386 '
    config_args='-de -Dusedevel -Duseithreads'
    hint=recommended, useposix=true, d_sigaction=define
    useithreads=define, usemultiplicity=define
    useperlio=define, d_sfio=undef, uselargefiles=define, usesocks=undef
    use64bitint=undef, use64bitall=undef, uselongdouble=undef
    usemymalloc=n, bincompat5005=undef
  Compiler:
    cc='cc', ccflags ='-fno-common -DPERL_DARWIN -fno-strict-aliasing -pipe -fstack-protector -I/usr/local/include',
    optimize='-O3',
    cppflags='-fno-common -DPERL_DARWIN -fno-strict-aliasing -pipe -fstack-protector -I/usr/local/include'
    ccversion='', gccversion='4.2.1 (Apple Inc. build 5664)', gccosandvers=''
    intsize=4, longsize=4, ptrsize=4, doublesize=8, byteorder=1234
    d_longlong=define, longlongsize=8, d_longdbl=define, longdblsize=16
    ivtype='long', ivsize=4, nvtype='double', nvsize=8, Off_t='off_t', lseeksize=8
    alignbytes=8, prototype=define
  Linker and Libraries:
    ld='env MACOSX_DEPLOYMENT_TARGET=10.3 cc', ldflags =' -fstack-protector -L/usr/local/lib'
    libpth=/usr/local/lib /usr/lib
    libs=-ldbm -ldl -lm -lutil -lc
    perllibs=-ldl -lm -lutil -lc
    libc=/usr/lib/libc.dylib, so=dylib, useshrplib=false, libperl=libperl.a
    gnulibc_version=''
  Dynamic Linking:
    dlsrc=dl_dlopen.xs, dlext=bundle, d_dlsymun=undef, ccdlflags=' '
    cccdlflags=' ', lddlflags=' -bundle -undefined dynamic_lookup -L/usr/local/lib -fstack-protector'

Locally applied patches:
    

---
@INC for perl 5.15.0:
    /usr/local/lib/perl5/site_perl/5.15.0/darwin-thread-multi-2level
    /usr/local/lib/perl5/site_perl/5.15.0
    /usr/local/lib/perl5/5.15.0/darwin-thread-multi-2level
    /usr/local/lib/perl5/5.15.0
    /usr/local/lib/perl5/site_perl
    .

---
Environment for perl 5.15.0:
    DYLD_LIBRARY_PATH (unset)
    HOME=/Users/sprout
    LANG=en_US.UTF-8
    LANGUAGE (unset)
    LD_LIBRARY_PATH (unset)
    LOGDIR (unset)
    PATH=/usr/bin:/bin:/usr/sbin:/sbin:/usr/local/bin:/usr/X11/bin:/usr/local/bin
    PERL_BADLANG (unset)
    SHELL=/bin/bash


Thread Next


nntp.perl.org: Perl Programming lists via nntp and http.
Comments to Ask Bjørn Hansen at ask@perl.org | Group listing | About